stages:
  - deploy

deploy_matrix:
  except:
    - branches
  only:
    - tags
  stage: deploy
  resource_group: deploy
  image: docker.io/archlinux:base-devel
  before_script:
  - pacman -Syu --noconfirm socat openssh git python ansible
  - eval $(ssh-agent -s)
  - echo "$SSH_PRIVATE_KEY" | base64 -d | tr -d '\r' | ssh-add -
  - mkdir -p ~/.ssh && chmod 700 ~/.ssh
  - echo "$SSH_SERVER_HOSTKEYS" | base64 -d > ~/.ssh/known_hosts && chmod 644 ~/.ssh/known_hosts
  script:
  - ssh "tux@$SERVER_ADDRESS" "paru -Syu --noconfirm && (sleep 5 && sudo reboot) & exit"
  - ansible-playbook --version
  - echo "$ANSIBLE_HOSTS" | base64 -d > ./inventory/hosts
  - mkdir "./inventory/host_vars/matrix.$SERVER_ADDRESS"
  - echo "$ANSIBLE_HOST_VARS" | base64 -d > ./inventory/host_vars/matrix.$SERVER_ADDRESS/vars.yml
  - make roles
  - sleep 150
  - ansible-playbook -i inventory/hosts setup.yml --tags=setup-all,start
